/*******************************************************************************
 *
 * File Name: LDsvg.h
 * Author: Richard Baxter
 * Project: Generic Construct Functions
 * Project Version: 2a4a 16-Oct-09
 *
 *******************************************************************************/



#ifndef HEADER_LD_SVG
#define HEADER_LD_SVG

#include "SHAREDglobalDefs.h"
#include "SHAREDvars.h"

void writeSVGFooter(ofstream * writeFileObject);
void writeSVGHeader(ofstream * writeFileObject);
void writeSVGLine(ofstream * writeFileObject, vec * pos1, vec * pos2, int col);
void writeSVGBox(ofstream * writeFileObject, vec * pos, double width, double height, int col, double boxOutlineWidth);
void writeSVGText(ofstream * writeFileObject, string text, vec * pos, int fontSize, int col);

#endif

